"use strict";

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _enjoyWebSupport = require("enjoy-web-support");

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { return step("next", value); }, function (err) { return step("throw", err); }); } } return step("next"); }); }; }

//距离失效3s 前重新请求签名
var JSSDKCONFIGTIME = 7197000;
//获取微信签名的跨域接口
var GETWXSIGN = "//mp.elong.com/mobilepromotion/getwxconfig";
//获取微信jssdk连接
var WXJSSDKURL = "//res.wx.qq.com/open/js/jweixin-1.0.0.js ";

exports.default = {
	updateSign: function updateSign() {
		if (!window["wx"]) {
			console.log("请正确引用jssdk");
			var oScript = document.createElement("script");
			oScript.type = "text/javascript";
			oScript.src = location.protocol + WXJSSDKURL;
			document.body.appendChild(oScript);
		}
		var now = new Date().getTime();
		window.configCallback = this.configCallback;
		//判断签名是否失效
		if ("weixinSign" in window && Number(window.weixinSign.timestamp) + JSSDKCONFIGTIME <= now) {
			return this.getSign();
		} else if (!window["weixinSign"]) {
			return this.getSign();
		} else {
			return;
		}
	},
	getSign: function getSign() {
		var _this = this;

		return _asyncToGenerator(regeneratorRuntime.mark(function _callee() {
			var nowTime, result;
			return regeneratorRuntime.wrap(function _callee$(_context) {
				while (1) {
					switch (_context.prev = _context.next) {
						case 0:
							_context.prev = 0;
							nowTime = new Date().getTime();
							_context.next = 4;
							return (0, _enjoyWebSupport.Fetch)(location.protocol + GETWXSIGN + '?callback=configCallback&v=' + nowTime, {
								method: 'Get',
								dataType: 'text'
							});

						case 4:
							result = _context.sent;

							eval(result);
							_context.next = 11;
							break;

						case 8:
							_context.prev = 8;
							_context.t0 = _context["catch"](0);

							console.log(JSON.stringify(_context.t0));

						case 11:
						case "end":
							return _context.stop();
					}
				}
			}, _callee, _this, [[0, 8]]);
		}))();
	},
	configCallback: function configCallback(resp) {
		if (resp.error == false && "wx" in window) {
			var data = resp.data;
			window.weixinSign = {
				debug: false,
				appId: data.appId,
				timestamp: data.timestamp,
				nonceStr: data.nonceStr,
				signature: data.signature,
				jsApiList: []
			};
			wx.config(Object.assign({}, window.weixinSign, {
				debug: false,
				jsApiList: ['getLocation', 'hideMenuItems', 'showMenuItems', 'hideAllNonBaseMenuItem', 'onMenuShareTimeline', 'onMenuShareAppMessage', 'onMenuShareQQ', 'onMenuShareQZone']
			}));
		}
	}
};