"use strict";

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _weixin = require("../lib/weixin");

var _weixin2 = _interopRequireDefault(_weixin);

var _enjoyWebSupport = require("enjoy-web-support");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { return step("next", value); }, function (err) { return step("throw", err); }); } } return step("next"); }); }; }

// function transPosition(position, info){
// 	var city = info.addressComponent.city;
// 	var province = info.addressComponent.province;
// 	if(city instanceof Array){
// 		city = city[0];
// 	}
// 	city = city || province;

// 	return {
// 		lat: position.latitude,
// 		lng: position.longitude,
// 		accuracy: position.accuracy,
// 		speed: position.speed,
// 		address: info.formatted_address,
// 		country: info.addressComponent.country,
// 		province: province,
// 		city: city.replace(/市$/, ""),
// 		district: info.addressComponent.district,
// 		streetName: info.addressComponent.streetNumber.street,
// 		streetNumber: info.addressComponent.streetNumber.number
// 	};
// }

var geting = false;
var list = [];

exports.default = {
	TIMEOUT: 13000,

	get: function get() {
		_enjoyWebSupport.Geolocation.TIMEOUT = this.TIMEOUT;

		return (0, _enjoyWebSupport.Promise)(function (resolve, reject) {
			// 备用定位
			// ios 10+ 使用qq定位
			// 其他使用h5定位
			var bakGeolocation = function () {
				var _ref = _asyncToGenerator(regeneratorRuntime.mark(function _callee3() {
					var osVersion, positionInfo;
					return regeneratorRuntime.wrap(function _callee3$(_context3) {
						while (1) {
							switch (_context3.prev = _context3.next) {
								case 0:
									if (!(/iPhone/i.test(navigator.userAgent) && (osVersion = navigator.userAgent.match(/OS\s+(\d+)/i)) && +osVersion[1] >= 10)) {
										_context3.next = 13;
										break;
									}

									_context3.prev = 1;
									_context3.next = 4;
									return _enjoyWebSupport.Geolocation._qqGeolocation(10000);

								case 4:
									positionInfo = _context3.sent;

									resolve(positionInfo);
									_context3.next = 11;
									break;

								case 8:
									_context3.prev = 8;
									_context3.t0 = _context3["catch"](1);

									reject(_context3.t0);

								case 11:
									_context3.next = 14;
									break;

								case 13:
									(0, _enjoyWebSupport.Promise)(function (resolve, reject) {
										var _this = this;

										navigator.geolocation.getCurrentPosition(function () {
											var _ref2 = _asyncToGenerator(regeneratorRuntime.mark(function _callee(position) {
												return regeneratorRuntime.wrap(function _callee$(_context) {
													while (1) {
														switch (_context.prev = _context.next) {
															case 0:
																resolve(position);

															case 1:
															case "end":
																return _context.stop();
														}
													}
												}, _callee, _this);
											}));

											return function (_x) {
												return _ref2.apply(this, arguments);
											};
										}(), function (e) {
											reject(e);
										});
									}, 3000).then(function () {
										var _ref3 = _asyncToGenerator(regeneratorRuntime.mark(function _callee2(position) {
											var _positionInfo;

											return regeneratorRuntime.wrap(function _callee2$(_context2) {
												while (1) {
													switch (_context2.prev = _context2.next) {
														case 0:
															_context2.prev = 0;
															_context2.next = 3;
															return _enjoyWebSupport.Geolocation._parsePosition(position, 4000);

														case 3:
															_positionInfo = _context2.sent;

															resolve(_positionInfo);
															_context2.next = 10;
															break;

														case 7:
															_context2.prev = 7;
															_context2.t0 = _context2["catch"](0);

															reject(_context2.t0);

														case 10:
														case "end":
															return _context2.stop();
													}
												}
											}, _callee2, this, [[0, 7]]);
										}));

										return function (_x2) {
											return _ref3.apply(this, arguments);
										};
									}()).catch(function (e) {
										reject(e);
									});

								case 14:
								case "end":
									return _context3.stop();
							}
						}
					}, _callee3, this, [[1, 8]]);
				}));

				return function bakGeolocation() {
					return _ref.apply(this, arguments);
				};
			}();

			// 优先使用wxjssk定位


			(0, _enjoyWebSupport.Promise)(function (resolve, reject) {
				_weixin2.default.ready(function () {
					wx.getLocation({
						type: 'wgs84', // 默认为wgs84的gps坐标，如果要返回直接给openLocation用的火星坐标，可传入'gcj02'
						success: function () {
							var _ref4 = _asyncToGenerator(regeneratorRuntime.mark(function _callee4(position) {
								return regeneratorRuntime.wrap(function _callee4$(_context4) {
									while (1) {
										switch (_context4.prev = _context4.next) {
											case 0:
												resolve(position);

											case 1:
											case "end":
												return _context4.stop();
										}
									}
								}, _callee4, this);
							}));

							function success(_x3) {
								return _ref4.apply(this, arguments);
							}

							return success;
						}(),
						fail: function fail(e) {
							reject(e);
						}
					});
				});
			}, 3000).then(function () {
				var _ref5 = _asyncToGenerator(regeneratorRuntime.mark(function _callee5(position) {
					var positionInfo;
					return regeneratorRuntime.wrap(function _callee5$(_context5) {
						while (1) {
							switch (_context5.prev = _context5.next) {
								case 0:
									_context5.prev = 0;
									_context5.next = 3;
									return _enjoyWebSupport.Geolocation._parsePosition(position, 4000);

								case 3:
									positionInfo = _context5.sent;

									resolve(positionInfo);
									_context5.next = 10;
									break;

								case 7:
									_context5.prev = 7;
									_context5.t0 = _context5["catch"](0);

									bakGeolocation();

								case 10:
								case "end":
									return _context5.stop();
							}
						}
					}, _callee5, this, [[0, 7]]);
				}));

				return function (_x4) {
					return _ref5.apply(this, arguments);
				};
			}()).catch(function (e) {
				bakGeolocation();
			});
		}, this.TIMEOUT);
	},


	// get(){
	// 	return $Promise((resolve, reject) => {
	// 		list.push(function(position, info){
	// 			if(info.info === "OK"){
	// 				resolve(transPosition(position, info.regeocode));
	// 			}else{
	// 				reject({
	// 					message: ""
	// 				});
	// 			}
	// 		});

	// 		if(!geting){
	// 			geting = true;

	// 			weixin.ready(() => {
	// 				wx.getLocation({
	// 					type: 'wgs84', // 默认为wgs84的gps坐标，如果要返回直接给openLocation用的火星坐标，可传入'gcj02'
	// 					success: async function (position) {
	// 						let info = await Fetch(location.protocol+`//restapi.amap.com/v3/geocode/regeo?output=json&location=${position.longitude},${position.latitude}&key=57d825abc441bf9851138bd1581567e6`);
	// 						// if(info.info === "OK"){
	// 						// 	resolve(transPosition(position, info.regeocode));
	// 						// }else{
	// 						// 	reject({
	// 						// 		message: ""
	// 						// 	});
	// 						// }
	// 						list.forEach(function(item){
	// 							item(position, info);
	// 						});
	// 						list = [];
	// 						geting = false;
	// 					},
	// 					fail:(ex) => {
	// 						alert(JSON.stringify(ex));
	// 					}
	// 				});
	// 			});
	// 		}
	// 	},this.TIMEOUT);
	// },

	watch: function watch(listener) {},
	clearWatch: function clearWatch() {}
};